package cn.com.tenlion.systembase.service.line;

import cn.com.tenlion.systembase.pojo.bos.line.LineBO;
import cn.com.tenlion.systembase.pojo.dtos.line.LineDTO;
import cn.com.tenlion.systembase.pojo.pos.line.LinePO;
import cn.com.tenlion.systembase.pojo.vos.line.LineVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: ILineService
 * @Description: 护路护线
 * @Author: CodeFactory
 * @Date: 2021-10-13 11:32:20
 * @Version: 3.0
 **/
public interface ILineService {

    /**
     * 新增护路护线
     *
     * @param lineVO
     * @return
     */
    void save(LineVO lineVO);

    /**
     * 新增护路护线
     *
     * @param token
     * @param lineVO
     * @return
     */
    void save(String token, LineVO lineVO);

    /**
     * 新增护路护线
     *
     * @param lineVO
     * @return lineId
     */
    String saveReturnId(LineVO lineVO);

    /**
     * 新增护路护线
     *
     * @param token
     * @param lineVO
     * @return lineId
     */
    String saveReturnId(String token, LineVO lineVO);

    /**
     * 删除护路护线
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除护路护线
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除护路护线（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改护路护线
     *
     * @param lineId
     * @param lineVO
     * @return
     */
    void update(String lineId, LineVO lineVO);

    /**
     * 修改护路护线
     *
     * @param token
     * @param lineId
     * @param lineVO
     * @return
     */
    void update(String token, String lineId, LineVO lineVO);

    /**
     * 护路护线详情
     *
     * @param params 参数Map
     * @return
     */
    LineDTO get(Map<String, Object> params);

    /**
     * 护路护线详情
     *
     * @param lineId
     * @return
     */
    LineDTO get(String lineId);

    /**
     * 护路护线详情
     *
     * @param params 参数Map
     * @return
     */
    LineBO getBO(Map<String, Object> params);

    /**
     * 护路护线详情
     *
     * @param lineId
     * @return
     */
    LineBO getBO(String lineId);

    /**
     * 护路护线详情
     *
     * @param params 参数Map
     * @return
     */
    LinePO getPO(Map<String, Object> params);

    /**
     * 护路护线详情
     *
     * @param lineId
     * @return
     */
    LinePO getPO(String lineId);

    /**
     * 护路护线列表
     *
     * @param params
     * @return
     */
    List<LineDTO> list(Map<String, Object> params);

    /**
     * 护路护线列表
     *
     * @param params
     * @return
     */
    List<LineBO> listBO(Map<String, Object> params);

    /**
     * 护路护线列表
     *
     * @param params
     * @return
     */
    List<LinePO> listPO(Map<String, Object> params);

    /**
     * 护路护线分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<LineDTO>> listPage(ListPage page);

    /**
     * 护路护线统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}